﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Projekteinteilung
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "Textdateien|*.txt";
            bool? resultat = ofd.ShowDialog();
            if (resultat == true)
            {
                List<Projekt> projekte = new List<Projekt>();
                List<Teilnehmer> nochZuVerteilendeTeilnehmer = new List<Teilnehmer>();
                Random zufall = new Random();

                string[] zeilen = File.ReadAllLines(ofd.FileName);
                for (int i = 0; i < zeilen.Length; i++)
                {
                    string[] teile = zeilen[i].Split(',');
                    if (teile.Length == 3)
                    {
                        projekte.Add(new Projekt(teile[1], teile[0], int.Parse(teile[2])));
                    }
                    else if (teile.Length == 4)
                    {
                        Projekt p1 = projekte.Find(x => x.Kurztitel == teile[1]);
                        Projekt p2 = projekte.Find(x => x.Kurztitel == teile[2]);
                        Projekt p3 = projekte.Find(x => x.Kurztitel == teile[3]);
                        nochZuVerteilendeTeilnehmer.Add(new Teilnehmer(teile[0], p1, p2, p3));
                    }
                    else
                    {
                        throw new ApplicationException("falsche Zahl an Kommas");
                    }
                }

                for (int w = 0; w < 3; w++)
                {
                    for (int i = 0; i < projekte.Count; i++)
                    {
                        int anm = nochZuVerteilendeTeilnehmer.Count(x => x.Projekt(w) == projekte[i]);
                        int frei = projekte[i].FreiePlätze;
                        if (frei >= anm)
                        {
                            // alle zulassen
                            int j = 0;
                            while (j < nochZuVerteilendeTeilnehmer.Count)
                            {
                                if (nochZuVerteilendeTeilnehmer[j].Projekt(w) == projekte[i])
                                {
                                    projekte[i].FügeHinzu(nochZuVerteilendeTeilnehmer[j]);
                                    nochZuVerteilendeTeilnehmer.RemoveAt(j);
                                }
                                else
                                {
                                    j++;
                                }
                            }
                        }
                        else
                        {
                            // losen
                            List<Teilnehmer> tnProj = nochZuVerteilendeTeilnehmer.FindAll(x => x.Projekt(w) == projekte[i]);
                            for (int k = 0; k < frei; k++)
                            {
                                int z = zufall.Next(tnProj.Count);
                                projekte[i].FügeHinzu(tnProj[z]);
                                nochZuVerteilendeTeilnehmer.Remove(tnProj[z]);
                                tnProj.RemoveAt(z);
                            }
                        }
                    }
                }

                ausgabe.Text = string.Join("\n\n", projekte.ConvertAll(x => x.ToString())); // nicht im Video
            }
        }
    }
}
